#include <stdio.h>
#include <inttypes.h>
#include <kernel/dpl/ClockP.h>
#include <kernel/dpl/SemaphoreP.h>
#include <drivers/ipc_notify.h>
#include "ti_drivers_open_close.h"
#include "ti_board_open_close.h"
#include <kernel/dpl/AddrTranslateP.h>
#include <drivers/gtc.h>


#define CSL_GTC_CFG1_CNTCV_LO                                              (0x00000008U)
#define CSL_GTC_CFG1_CNTCV_HI                                              (0x0000000CU)

void ipc_notify_msg_handler_remote_core(uint32_t remoteCoreId, uint16_t localClientId, uint32_t msgValue, int32_t crcStatus, void *args);
volatile uint64_t Time = 0U;
volatile uint32_t  count = 0U;

void GTC_reset(void);


void ipc_rpmsg_echo_remote_core_start(void)
{

    int32_t status ;
    uint64_t clkRate = 0;

    /* register a handler to receive messages */
    status = IpcNotify_registerClient(4, ipc_notify_msg_handler_remote_core, NULL);
    DebugP_assert(status==SystemP_SUCCESS);

    /* wait for all cores to be ready */
    IpcNotify_syncAll(SystemP_WAIT_FOREVER);



    status = SOC_moduleGetClockFrequency(TISCI_DEV_GTC0, TISCI_DEV_GTC0_GTC_CLK, &clkRate);

    if (status == SystemP_SUCCESS)
       {

         DebugP_log(" GTC clock %x  ...\r\n", clkRate);

       }


}


volatile uint32_t Dma_cmpltion_flag = 0U;


void ipc_notify_msg_handler_remote_core(uint32_t remoteCoreId, uint16_t localClientId, uint32_t msgValue, int32_t crcStatus, void *args)
{

    volatile uint64_t GTCDMAstop = 0U;
    //volatile uint64_t GTCDMAStart = 0U;

    if(msgValue == 0x5A5A)
    {
        count++;
        GTCDMAstop = GTC_getCount64();
        //GTCDMAStart = ( (uint64_t) *( (uint32_t *)0x40 ) << 32U ) |  ( *( (uint32_t *)0x44 ) ) ;
        //Time = GTCDMAstop - GTCDMAStart;
        Time = GTCDMAstop;
        //GTC_reset();
        Dma_cmpltion_flag = 0xFF;
        /* on remote core, we have registered handler on the same client ID and current core client ID */
        IpcNotify_sendMsg(remoteCoreId, localClientId, 0xA5A5, 1);
    }



}

void GTC_reset(void)
{

uint32_t baseAddr = (uint32_t) AddrTranslateP_getLocalAddr(CSL_GTC0_GTC_CFG1_BASE);


    HW_WR_REG32( (baseAddr + CSL_GTC_CFG1_CNTCV_HI), 0x00 ) ;
    HW_WR_REG32( (baseAddr + CSL_GTC_CFG1_CNTCV_LO),0x00)  ;


}
